/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 10 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:339  */

#include <stdio.h>
#include <stdlib.h>
#include "opcodes.h"

extern int   yylineno;
extern void  update_branch(void *a,void *b);
extern void *new_code(int opcode,char *carg,int iarg,int line);
extern void  new_context(char *name,int handler,int user,int oo);
extern void  start_global(char *name);
extern void  end_global(char *name);
extern void  end_context(char *name);
extern void  argument_count(int);
extern void  argument_type(char*);
extern void  extern_command(char*,char*);
extern char *strdup(const char*);

static void *stack[1024];
static int  top = 0;

static int  tmpdepth = 0;

static void include(char*);
static void begin_function(char *name,int handler,int user,int oo)
{
	/* extern int yydebug; yydebug = 1; */
	new_context(name,handler,user,oo);
}

static void return_function(int has_value)
{
	if(!has_value) new_code(OP_PUSH,NULL,PUSH_NIL,yylineno);
	new_code(OP_RETURN,NULL,0,yylineno);
}

static void end_function(char *name)
{
	new_code(OP_PUSH,NULL,PUSH_NIL,yylineno);
	new_code(OP_RETURN,NULL,0,yylineno);

	end_context(name);
}

static void begin_while()
{
	stack[top++] = new_code(OP_NOP,NULL,0,yylineno);
}

static void end_while()
{
	void *l1 = stack[--top];
	void *l2 = stack[--top];
	update_branch(new_code(OP_GOTO,NULL,0,yylineno),l2);
	update_branch(l1,new_code(OP_NOP,NULL,0,yylineno));
}

static void begin_repeat()
{
	stack[top++] = new_code(OP_NOP,NULL,0,yylineno);
}

static void end_until()
{
	void *l = stack[--top];
	update_branch(new_code(OP_TEST,NULL,0,yylineno),l);
}

static void do_while()
{
	stack[top++] = new_code(OP_TEST,NULL,0,yylineno);
}


static void begin_if()
{
	stack[top++] = new_code(OP_TEST,NULL,0,yylineno);
}

static void else_if()
{
	void *l = stack[--top];

	stack[top++] = new_code(OP_GOTO,NULL,0,yylineno);
	update_branch(l,new_code(OP_NOP,NULL,0,yylineno));
}

static void end_if()
{
	void *l = stack[--top];
	update_branch(l,new_code(OP_NOP,NULL,0,yylineno));
}

static void push(char *name,int type)
{
	new_code(OP_PUSH,name,type,yylineno);
}


static void param(char *name,char *type)
{
	new_code(OP_PARAM,name,0,yylineno);
	argument_type(type);
}

static void pop(char *name,int n)
{
	if(name)
		new_code(OP_STORE,name,n,yylineno);
	else
		new_code(OP_POP,NULL,n,yylineno);
}

static void call(char *name,int arity)
{
	new_code(OP_CALL,name,arity,yylineno);
}

/*===========================================================================*/

static void begin_case(void)
{
	void *l1,*l2,*l3;
	char tmp[20];

	sprintf(tmp,".tmp.%d",tmpdepth++);
	pop(tmp,0);

	l1 = new_code(OP_GOTO,NULL,0,yylineno);
	l2 = new_code(OP_GOTO,NULL,0,yylineno); /* endcase case */
	l3 = new_code(OP_NOP, NULL,0,yylineno);

	update_branch(l1,l3);
	stack[top++] = l2;
}

static void end_case(void)
{
	void *l = stack[--top];
	update_branch(l,new_code(OP_NOP,NULL,0,yylineno));
	tmpdepth--;
}

static void begin_choice(int count)
{
	char tmp1[20];
	char tmp2[20];

	sprintf(tmp1,".tmp.%d",tmpdepth-1);

	if(count == 1) /* faster */
	{
		push(tmp1,PUSH_IDENT);
		call("=", 2);
	}
	else
	{
		int i;
		for(i=0;i<count;i++)  /* copy all cases */
		{
			sprintf(tmp2,".tmp.%d",tmpdepth+i);
			pop(tmp2,0);
		}

		for(i=0;i<count;i++)  /* = all cases */
		{
			sprintf(tmp2,".tmp.%d",tmpdepth+i);
			push(tmp1,PUSH_IDENT);
			push(tmp2,PUSH_IDENT);
			call("=", 2);
		}

		for(i=0;i<count-1;i++)  /* or all cases */
			call("or",2);
	}

	stack[top++] = new_code(OP_TEST,NULL,0,yylineno);

}

static void end_choice(void)
{
	void *l1 = stack[--top]; /* OP_TEST */
	void *l2 = stack[top-1]; /* begin_case l2 */

	update_branch(new_code(OP_GOTO,NULL,0,yylineno),l2);
	update_branch(l1,new_code(OP_NOP ,NULL,0,yylineno));
}

/*===========================================================================*/

static begin_for(char *name,int by)
{
	char tmp1[20];
	char tmp2[20];

	sprintf(tmp1,".tmp.%d",tmpdepth++);
	sprintf(tmp2,".tmp.%d",tmpdepth++);

	if(by == 0) push("1",PUSH_NUMBER); /* default by */

	pop(tmp2,0);             /* by is on top */

	push(name,PUSH_IDENT); /*  end - start (end is on stack)  */
	call("-",2);

	push(tmp2,PUSH_IDENT); /*  end - start + by */
	call("+",2);

	push(tmp2,PUSH_IDENT); /*  (end - start + 1)/by */
	call("/",2);
	call("int",1);
	pop(tmp1,0);             /* into tmp var */

	begin_while();         /* while tmp > 0 */

	push(tmp1,PUSH_IDENT);
	push("0",PUSH_NUMBER);
	call(">",2);

	do_while();

}

static end_for(char *name)
{
	char tmp1[20];
	char tmp2[20];

	sprintf(tmp2,".tmp.%d",--tmpdepth);
	sprintf(tmp1,".tmp.%d",--tmpdepth);

	push(name,PUSH_IDENT); /* name = name + by */
	push(tmp2,PUSH_IDENT);
	call("+",2);
	pop(name,0);

	push(tmp1,PUSH_IDENT); /* tmp = tmp - 1 */
	push("1",PUSH_NUMBER);
	call("-",2);
	pop(tmp1,0);

	end_while();

/* pmit@up*/
}

/*===========================================================================*/

static begin_loop(char *name)
{
	char tmp1[20];
	char tmp2[20];
	char tmp3[20];

	sprintf(tmp1,".tmp.%d",tmpdepth++);
	sprintf(tmp2,".tmp.%d",tmpdepth++);
	sprintf(tmp3,".tmp.%d",tmpdepth++);

	pop(tmp2,0);             /* get list */
	push(tmp2,PUSH_IDENT);
	call("count",1);       /* count */

	pop(tmp1,0);             /* into tmp var */

	push("1",PUSH_NUMBER);
	pop(tmp3,0);

	begin_while();         /* while tmp > 0 */

	push(tmp1,PUSH_IDENT);
	push("0",PUSH_NUMBER);
	call(">",2);

	do_while();

	push(tmp2,PUSH_IDENT);	
	push(tmp3,PUSH_IDENT);	
	call("[]",2);
	pop(name,0);

}

static end_loop()
{
	char tmp1[20];
	char tmp2[20];
	char tmp3[20];

	sprintf(tmp3,".tmp.%d",--tmpdepth);
	sprintf(tmp2,".tmp.%d",--tmpdepth);
	sprintf(tmp1,".tmp.%d",--tmpdepth);

	push(tmp1,PUSH_IDENT); /* tmp = tmp - 1 */
	push("1",PUSH_NUMBER);
	call("-",2);
	pop(tmp1,0);

	push(tmp3,PUSH_IDENT); /* tmp = tmp + 1 */
	push("1",PUSH_NUMBER);
	call("+",2);
	pop(tmp3,0);

	end_while();

}

/*===========================================================================*/

static void begin_when(void)
{
	void *l1,*l2,*l3;

	l1 = new_code(OP_GOTO,NULL,0,yylineno);
	l2 = new_code(OP_GOTO,NULL,0,yylineno); /* endcase when */
	l3 = new_code(OP_NOP, NULL,0,yylineno);

	update_branch(l1,l3);
	stack[top++] = l2;
}

static void end_when(void)
{
	void *l = stack[--top];
	update_branch(l,new_code(OP_NOP,NULL,0,yylineno));
}

static void begin_selection(void)
{
	stack[top++] = new_code(OP_TEST,NULL,0,yylineno);
}

static void end_selection(void)
{
	void *l1 = stack[--top]; /* OP_TEST */
	void *l2 = stack[top-1]; /* begin_when l2 */

	update_branch(new_code(OP_GOTO,NULL,0,yylineno),l2);
	update_branch(l1,new_code(OP_NOP ,NULL,0,yylineno));
}

/*===========================================================================*/

#line 409 "y.tab.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif


/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    IF = 258,
    AND = 259,
    NOT = 260,
    OR = 261,
    THEN = 262,
    ELSE = 263,
    END = 264,
    RETURN = 265,
    DO = 266,
    FUNCTION = 267,
    ON = 268,
    GLOBAL = 269,
    VECTOR = 270,
    WHILE = 271,
    INCLUDE = 272,
    EXTERN = 273,
    GE = 274,
    LE = 275,
    NE = 276,
    FOR = 277,
    TO = 278,
    BY = 279,
    NIL = 280,
    OBJECT = 281,
    IMPORT = 282,
    EXPORT = 283,
    INLINE = 284,
    CASE = 285,
    OTHERWISE = 286,
    OF = 287,
    IN = 288,
    REPEAT = 289,
    UNTIL = 290,
    LOOP = 291,
    WHEN = 292,
    TELL = 293,
    TASK = 294,
    ARROW = 295,
    WORD = 296,
    STRING = 297,
    NUMBER = 298,
    DATE = 299,
    TIME = 300,
    ENDINLINE = 301
  };
#endif
/* Tokens.  */
#define IF 258
#define AND 259
#define NOT 260
#define OR 261
#define THEN 262
#define ELSE 263
#define END 264
#define RETURN 265
#define DO 266
#define FUNCTION 267
#define ON 268
#define GLOBAL 269
#define VECTOR 270
#define WHILE 271
#define INCLUDE 272
#define EXTERN 273
#define GE 274
#define LE 275
#define NE 276
#define FOR 277
#define TO 278
#define BY 279
#define NIL 280
#define OBJECT 281
#define IMPORT 282
#define EXPORT 283
#define INLINE 284
#define CASE 285
#define OTHERWISE 286
#define OF 287
#define IN 288
#define REPEAT 289
#define UNTIL 290
#define LOOP 291
#define WHEN 292
#define TELL 293
#define TASK 294
#define ARROW 295
#define WORD 296
#define STRING 297
#define NUMBER 298
#define DATE 299
#define TIME 300
#define ENDINLINE 301

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 353 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:355  */

	char       *str;
	long		num;

#line 543 "y.tab.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);



/* Copy the second part of user declarations.  */

#line 560 "y.tab.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  128
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   592

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  65
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  86
/* YYNRULES -- Number of rules.  */
#define YYNRULES  192
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  336

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   301

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    62,     2,
      49,    50,    59,    61,    52,    57,    55,    60,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    51,    47,
      64,    48,    63,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    53,     2,    54,    58,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    56,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   426,   426,   429,   430,   433,   434,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   448,   450,   452,   452,
     456,   460,   464,   465,   468,   472,   475,   476,   479,   484,
     487,   488,   489,   492,   493,   494,   497,   498,   504,   505,
     508,   511,   512,   515,   516,   519,   521,   522,   528,   529,
     530,   531,   534,   535,   539,   540,   545,   545,   551,   551,
     561,   562,   563,   564,   565,   566,   567,   568,   573,   573,
     580,   580,   587,   587,   591,   592,   595,   595,   600,   600,
     606,   607,   610,   610,   614,   615,   621,   621,   628,   629,
     628,   634,   635,   640,   641,   640,   648,   648,   653,   654,
     654,   655,   656,   655,   663,   664,   665,   669,   670,   671,
     672,   673,   674,   678,   682,   689,   700,   710,   711,   714,
     715,   718,   721,   721,   722,   722,   725,   726,   727,   728,
     731,   732,   735,   738,   740,   743,   744,   747,   748,   749,
     751,   752,   753,   754,   755,   756,   757,   758,   759,   762,
     763,   768,   769,   772,   773,   774,   777,   778,   779,   780,
     783,   784,   785,   786,   787,   788,   789,   790,   791,   792,
     795,   796,   799,   800,   803,   806,   807,   808,   809,   810,
     811,   812,   813,   814,   815,   816,   817,   818,   819,   820,
     821,   822,   825
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "IF", "AND", "NOT", "OR", "THEN", "ELSE",
  "END", "RETURN", "DO", "FUNCTION", "ON", "GLOBAL", "VECTOR", "WHILE",
  "INCLUDE", "EXTERN", "GE", "LE", "NE", "FOR", "TO", "BY", "NIL",
  "OBJECT", "IMPORT", "EXPORT", "INLINE", "CASE", "OTHERWISE", "OF", "IN",
  "REPEAT", "UNTIL", "LOOP", "WHEN", "TELL", "TASK", "ARROW", "WORD",
  "STRING", "NUMBER", "DATE", "TIME", "ENDINLINE", "';'", "'='", "'('",
  "')'", "':'", "','", "'['", "']'", "'.'", "'|'", "'-'", "'^'", "'*'",
  "'/'", "'+'", "'&'", "'>'", "'<'", "$accept", "script", "block", "lines",
  "line", "name", "declare", "$@1", "import", "export", "extern",
  "extern_name", "include", "inline", "function", "param_declare",
  "functionheader", "super_declare", "super_list", "super", "param_list",
  "param", "endfunction", "fname", "statement", "return", "assignement",
  "$@2", "$@3", "control", "loop", "$@4", "tell", "$@5", "when", "$@6",
  "selections", "selection", "$@7", "case", "$@8", "choices", "choice",
  "$@9", "otherwise", "repeat", "$@10", "for", "$@11", "$@12", "by",
  "while", "$@13", "$@14", "if", "$@15", "closeif", "$@16", "$@17", "$@18",
  "definition", "function_call", "inline_object", "param_or_empty",
  "parameters", "parameter", "attribute", "$@19", "$@20", "attribute_list",
  "vector_list", "matrix", "vector", "list", "number", "atom",
  "atom_or_number", "power", "factor", "term", "condition", "conjonction",
  "disjonction", "expression", "operator", "empty", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,    59,    61,    40,
      41,    58,    44,    91,    93,    46,   124,    45,    94,    42,
      47,    43,    38,    62,    60
};
# endif

#define YYPACT_NINF -279

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-279)))

#define YYTABLE_NINF -143

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     417,   466,   466,   355,   355,   -15,  -279,    16,   355,   -15,
    -279,   355,   -15,   -15,   466,  -279,   -15,  -279,   466,  -279,
    -279,    -7,  -279,  -279,    34,   466,   466,   535,    68,  -279,
     417,  -279,    59,  -279,  -279,  -279,  -279,    23,  -279,  -279,
      23,  -279,  -279,  -279,  -279,  -279,  -279,  -279,  -279,  -279,
    -279,  -279,  -279,  -279,    27,  -279,    33,  -279,    33,  -279,
     -19,  -279,   466,  -279,   508,    24,  -279,  -279,   -19,    37,
    -279,   -37,    -1,    22,    96,    95,    97,  -279,  -279,  -279,
    -279,  -279,  -279,  -279,  -279,  -279,    61,  -279,  -279,  -279,
    -279,  -279,  -279,  -279,  -279,  -279,  -279,  -279,  -279,    72,
     466,  -279,  -279,  -279,    73,  -279,  -279,  -279,    84,   417,
      93,   466,  -279,  -279,    74,  -279,    94,    77,    78,    82,
      86,    85,  -279,    88,  -279,  -279,    90,   -19,  -279,  -279,
     101,   -15,   466,   487,   466,    28,  -279,   -21,    99,  -279,
      91,  -279,  -279,   466,    51,    22,  -279,   529,   529,   529,
     529,   529,   529,   115,   529,   529,   529,   529,   529,   529,
     529,   466,   466,  -279,  -279,  -279,   138,   466,  -279,   116,
     466,   113,  -279,   102,   417,   108,   109,   487,   487,  -279,
    -279,  -279,   466,  -279,  -279,   114,  -279,   100,   112,   117,
     111,   120,   127,  -279,   125,    46,  -279,   151,   535,   417,
    -279,   128,  -279,  -279,  -279,  -279,  -279,   -37,   -37,   -37,
     529,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    96,
     417,   466,  -279,  -279,   466,   466,  -279,   144,  -279,  -279,
     174,   466,   466,   135,  -279,   134,  -279,  -279,   487,  -279,
     487,  -279,   139,  -279,  -279,   -15,  -279,   -15,  -279,   136,
    -279,    27,   182,  -279,    -1,    54,  -279,   417,   169,   444,
    -279,   142,  -279,   417,  -279,   417,   156,  -279,  -279,  -279,
     487,   146,   147,   466,   466,   466,  -279,  -279,   535,   355,
    -279,   195,   199,  -279,   194,   466,   153,  -279,   196,  -279,
    -279,   197,   198,  -279,   134,  -279,  -279,  -279,  -279,  -279,
    -279,  -279,  -279,   417,  -279,   200,   186,   417,   187,   417,
     176,  -279,   466,    54,  -279,   466,   207,  -279,   210,  -279,
     212,  -279,   215,  -279,  -279,  -279,  -279,  -279,  -279,   417,
     417,   214,    54,   202,  -279,  -279
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
     192,     0,    52,     0,     0,     0,    93,     0,     0,     0,
     147,     0,     0,     0,     0,    86,     0,    72,     0,    16,
     138,   140,   141,    15,     0,   192,     0,     0,     0,     2,
       3,     5,    51,    10,    12,    13,    11,   192,    14,     8,
     192,     7,    50,    48,     9,    65,    67,    66,    64,    63,
      62,    61,    60,   109,    49,   110,   132,   146,   145,   144,
       0,     4,     0,   135,     0,   137,   142,   150,   149,   152,
     155,   159,   169,   171,   173,   174,     0,    53,   189,   182,
     190,   178,   179,   180,   181,   176,     0,   187,   183,   184,
     185,   186,   188,   175,   177,    46,    33,    47,    34,    17,
       0,    26,    27,    25,     0,    35,    20,    21,     0,   192,
       0,     0,    70,   139,   138,   106,   137,     0,   126,     0,
     121,     0,   118,   119,   121,   117,     0,   148,     1,     6,
       0,     0,     0,   192,     0,     0,   116,     0,    22,    30,
     192,   131,   130,     0,     0,   168,   136,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    96,   191,    18,     0,     0,    78,     0,
       0,     0,    74,     0,   192,     0,     0,     0,     0,   104,
     143,   134,     0,   133,    28,     0,    54,     0,   119,     0,
       0,     0,     0,    31,    43,     0,    41,    23,     0,   192,
      36,     0,   113,   112,   151,   153,   154,   157,   156,   158,
       0,   163,   164,   165,   166,   161,   160,   162,   170,   172,
     192,     0,    94,    88,     0,     0,    68,     0,    75,    76,
       0,     0,     0,     0,   129,   127,   128,   120,   192,   107,
       0,   108,     0,    58,    56,     0,    32,     0,    24,    37,
      38,    40,     0,   111,   167,     0,    19,   192,     0,   192,
      80,     0,    87,   192,    73,   192,     0,   125,   123,   105,
       0,     0,     0,     0,     0,     0,    44,    42,     0,     0,
      29,    99,     0,    97,     0,     0,     0,    81,     0,    84,
      82,     0,     0,    71,     0,   114,   115,    55,    59,    57,
      39,    45,   101,   192,    98,     0,   192,   192,     0,   192,
       0,    77,     0,     0,    95,     0,     0,    91,     0,    79,
       0,    69,     0,   100,    92,    89,    85,    83,   102,   192,
     192,     0,     0,     0,   103,    90
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -279,  -279,    92,  -279,   201,     0,  -279,  -279,  -279,  -279,
    -279,  -279,  -279,    29,  -279,   185,  -279,  -279,  -279,   -51,
    -279,   -18,  -279,    17,  -279,  -279,  -279,  -279,  -279,  -279,
    -279,  -279,  -279,  -279,  -279,  -279,  -279,    57,  -279,  -279,
    -279,  -279,   -22,  -279,  -279,  -279,  -279,  -279,  -279,  -279,
    -279,  -279,  -279,  -279,  -279,  -279,  -278,  -279,  -279,  -279,
    -279,    15,  -279,  -132,    18,    -6,  -279,  -279,  -279,    -5,
    -279,  -279,    55,  -279,  -279,    10,  -279,  -116,   -85,  -108,
     -56,    81,  -279,    79,  -279,   -23
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    28,    29,    30,    31,    65,    33,   221,    34,    35,
      36,    37,    38,   136,    39,   138,    40,   199,   249,   250,
     195,   196,   280,    96,    41,    42,    43,   275,   274,    44,
      45,   263,    46,   174,    47,   111,   171,   172,   265,    48,
     224,   259,   260,   309,   288,    49,   109,    50,   258,   329,
     316,    51,   100,   257,    52,   220,   283,   303,   312,   330,
      53,    66,    55,   121,   122,   123,   118,   176,   175,   234,
      56,    57,    58,    59,    67,    68,    69,    70,    71,    72,
      73,    74,    75,   124,    97,    61
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      32,   187,   125,    95,    95,    99,   145,   102,    95,   104,
      60,    95,   106,   107,   139,    54,   110,   139,   117,   119,
      19,    98,   148,   149,   116,   103,    19,   153,   105,   193,
      32,   204,   205,   206,   143,   323,   144,   127,   113,    62,
      60,   154,   155,   156,   126,    54,   211,   212,   213,   214,
     215,   216,   217,   130,   334,   157,   150,    19,   101,    10,
     151,   152,   281,   282,   131,   207,   208,   209,   128,    19,
     158,   191,   137,   133,   127,    19,   114,    63,    21,    22,
      76,    77,  -142,    24,   115,   159,   160,    25,   130,    26,
      26,    64,    19,   108,   202,   147,   246,   112,   247,   131,
     161,   162,   254,   120,   163,   218,   271,   132,   133,    32,
     125,   141,   134,   142,   135,   164,   168,   200,    62,    60,
     165,   167,   227,   130,    54,  -124,   170,   188,   189,   177,
     178,   185,   179,   116,   131,   192,   180,   194,    10,   181,
     182,   197,   198,   133,   203,  -122,   183,   184,   210,   222,
     239,   225,   190,   229,    19,    20,    63,    21,    22,   231,
     232,   201,    24,   238,   240,   242,    25,   241,   243,    26,
      64,   188,   235,   236,    32,   244,   245,   116,   116,   166,
     130,   264,   253,   266,    60,   269,   270,   273,   278,    54,
     173,   279,   285,   290,   293,   233,   295,   296,   302,    32,
     237,   169,   304,   305,   307,   308,   310,   311,    60,    60,
     315,   186,   321,   251,    54,   125,   314,   319,   325,   326,
      32,   327,   328,   333,   335,   140,   248,   300,   228,   277,
      60,   129,   188,   272,   188,    54,   289,   287,   116,     0,
     116,     0,   261,   219,     0,   276,   223,   194,     0,   226,
     173,     0,     0,     0,     0,     0,     0,    32,   237,     0,
       0,     0,     0,    32,   294,    32,   230,    60,     0,     0,
     116,     0,    54,    60,     0,    60,     0,   261,    54,    95,
      54,     0,     0,   317,     0,     0,     0,     0,    60,     0,
       0,   252,     0,   251,     0,     0,   301,     0,     0,     0,
     256,     0,     0,    32,   262,     0,     0,    32,     0,    32,
     267,   268,   255,    60,     0,     0,     0,    60,    54,    60,
       0,     0,    54,     0,    54,     0,     0,     0,     0,    32,
      32,     0,     0,     0,     0,     0,     0,     0,     0,    60,
      60,     0,     0,     0,    54,    54,     0,     0,     0,   284,
       0,     0,   297,   298,   299,   291,     0,   292,     0,    78,
      79,    80,     0,     0,   306,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    81,    82,    83,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    84,     0,
       0,   322,     0,     0,   324,   313,    19,     0,     0,   318,
       0,   320,     0,    85,     0,     0,     0,     0,    86,     0,
       0,     0,    87,    88,    89,    90,    91,    92,    93,    94,
       1,   331,   332,     0,     0,     0,     0,     2,     0,     3,
       4,     5,     0,     6,     7,     8,     0,     0,     0,     9,
       0,     0,    10,    11,    12,    13,     0,    14,     0,    62,
       0,    15,     0,    16,    17,    18,     0,     0,    19,    20,
       0,    21,    22,     0,    23,     0,    24,     0,     0,    10,
      25,    62,     0,    26,    27,   286,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    19,    20,    63,    21,    22,
       0,    10,    62,    24,     0,     0,     0,    25,     0,     0,
      26,    64,     0,     0,     0,     0,     0,    19,    20,    63,
      21,    22,    10,     0,     0,    24,     0,     0,     0,    25,
       0,     0,    26,    64,     0,     0,     0,     0,    19,   114,
      63,    21,    22,    10,     0,     0,    24,     0,     0,     0,
      25,     0,     0,    26,    64,     0,     0,     0,     0,    19,
      20,   146,    21,    22,    10,     0,     0,    24,     0,     0,
      10,    25,     0,     0,    26,    27,     0,     0,     0,     0,
      19,    20,    63,    21,    22,     0,    19,    20,    24,    21,
      22,     0,    25,     0,    24,    26,    64,     0,    25,     0,
       0,    26,    27
};

static const yytype_int16 yycheck[] =
{
       0,   133,    25,     3,     4,     5,    62,     7,     8,     9,
       0,    11,    12,    13,    37,     0,    16,    40,    24,    24,
      41,     4,    59,    60,    24,     8,    41,     5,    11,    50,
      30,   147,   148,   149,    53,   313,    55,    27,    45,     5,
      30,    19,    20,    21,    26,    30,   154,   155,   156,   157,
     158,   159,   160,    29,   332,    33,    57,    41,    42,    25,
      61,    62,     8,     9,    40,   150,   151,   152,     0,    41,
      48,    43,    49,    49,    64,    41,    42,    43,    44,    45,
       1,     2,    55,    49,    50,    63,    64,    53,    29,    56,
      56,    57,    41,    14,    43,    58,    50,    18,    52,    40,
       4,     6,   210,    24,     7,   161,   238,    48,    49,   109,
     133,    56,    53,    58,    55,    54,    32,   140,     5,   109,
      48,    48,     9,    29,   109,    51,    33,   133,   133,    52,
      52,   131,    50,   133,    40,   135,    50,   137,    25,    54,
      52,    42,    51,    49,   144,    51,    56,    46,    33,    11,
      50,    35,   134,    51,    41,    42,    43,    44,    45,    51,
      51,   143,    49,    49,    52,    54,    53,    50,    48,    56,
      57,   177,   178,   178,   174,    48,    51,   177,   178,   100,
      29,    37,    54,     9,   174,    50,    52,    48,    52,   174,
     111,     9,    23,    51,    38,   177,    50,    50,     3,   199,
     182,   109,     3,     9,    51,     9,     9,     9,   198,   199,
      24,   132,    36,   198,   199,   238,    16,    30,    11,     9,
     220,     9,     7,     9,    22,    40,   197,   278,   171,   247,
     220,    30,   238,   238,   240,   220,   259,   259,   238,    -1,
     240,    -1,   224,   162,    -1,   245,   167,   247,    -1,   170,
     171,    -1,    -1,    -1,    -1,    -1,    -1,   257,   240,    -1,
      -1,    -1,    -1,   263,   270,   265,   174,   257,    -1,    -1,
     270,    -1,   257,   263,    -1,   265,    -1,   259,   263,   279,
     265,    -1,    -1,   306,    -1,    -1,    -1,    -1,   278,    -1,
      -1,   199,    -1,   278,    -1,    -1,   279,    -1,    -1,    -1,
     221,    -1,    -1,   303,   225,    -1,    -1,   307,    -1,   309,
     231,   232,   220,   303,    -1,    -1,    -1,   307,   303,   309,
      -1,    -1,   307,    -1,   309,    -1,    -1,    -1,    -1,   329,
     330,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   329,
     330,    -1,    -1,    -1,   329,   330,    -1,    -1,    -1,   257,
      -1,    -1,   273,   274,   275,   263,    -1,   265,    -1,     4,
       5,     6,    -1,    -1,   285,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    19,    20,    21,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    -1,
      -1,   312,    -1,    -1,   315,   303,    41,    -1,    -1,   307,
      -1,   309,    -1,    48,    -1,    -1,    -1,    -1,    53,    -1,
      -1,    -1,    57,    58,    59,    60,    61,    62,    63,    64,
       3,   329,   330,    -1,    -1,    -1,    -1,    10,    -1,    12,
      13,    14,    -1,    16,    17,    18,    -1,    -1,    -1,    22,
      -1,    -1,    25,    26,    27,    28,    -1,    30,    -1,     5,
      -1,    34,    -1,    36,    37,    38,    -1,    -1,    41,    42,
      -1,    44,    45,    -1,    47,    -1,    49,    -1,    -1,    25,
      53,     5,    -1,    56,    57,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    41,    42,    43,    44,    45,
      -1,    25,     5,    49,    -1,    -1,    -1,    53,    -1,    -1,
      56,    57,    -1,    -1,    -1,    -1,    -1,    41,    42,    43,
      44,    45,    25,    -1,    -1,    49,    -1,    -1,    -1,    53,
      -1,    -1,    56,    57,    -1,    -1,    -1,    -1,    41,    42,
      43,    44,    45,    25,    -1,    -1,    49,    -1,    -1,    -1,
      53,    -1,    -1,    56,    57,    -1,    -1,    -1,    -1,    41,
      42,    43,    44,    45,    25,    -1,    -1,    49,    -1,    -1,
      25,    53,    -1,    -1,    56,    57,    -1,    -1,    -1,    -1,
      41,    42,    43,    44,    45,    -1,    41,    42,    49,    44,
      45,    -1,    53,    -1,    49,    56,    57,    -1,    53,    -1,
      -1,    56,    57
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     3,    10,    12,    13,    14,    16,    17,    18,    22,
      25,    26,    27,    28,    30,    34,    36,    37,    38,    41,
      42,    44,    45,    47,    49,    53,    56,    57,    66,    67,
      68,    69,    70,    71,    73,    74,    75,    76,    77,    79,
      81,    89,    90,    91,    94,    95,    97,    99,   104,   110,
     112,   116,   119,   125,   126,   127,   135,   136,   137,   138,
     140,   150,     5,    43,    57,    70,   126,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   148,     4,     5,
       6,    19,    20,    21,    33,    48,    53,    57,    58,    59,
      60,    61,    62,    63,    64,    70,    88,   149,    88,    70,
     117,    42,    70,    88,    70,    88,    70,    70,   148,   111,
      70,   100,   148,    45,    42,    50,    70,   130,   131,   134,
     148,   128,   129,   130,   148,   150,   129,   140,     0,    69,
      29,    40,    48,    49,    53,    55,    78,    49,    80,   150,
      80,   137,   137,    53,    55,   145,    43,    58,    59,    60,
      57,    61,    62,     5,    19,    20,    21,    33,    48,    63,
      64,     4,     6,     7,    54,    48,   148,    48,    32,    67,
      33,   101,   102,   148,    98,   133,   132,    52,    52,    50,
      50,    54,    52,    56,    46,    70,   148,   128,   130,   134,
     129,    43,    70,    50,    70,    85,    86,    42,    51,    82,
     150,   129,    43,    70,   142,   142,   142,   143,   143,   143,
      33,   144,   144,   144,   144,   144,   144,   144,   145,   146,
     120,    72,    11,   148,   105,    35,   148,     9,   102,    51,
      67,    51,    51,   129,   134,   130,   134,   129,    49,    50,
      52,    50,    54,    48,    48,    51,    50,    52,    78,    83,
      84,   126,    67,    54,   144,    67,   148,   118,   113,   106,
     107,   129,   148,    96,    37,   103,     9,   148,   148,    50,
      52,   128,   134,    48,    93,    92,    70,    86,    52,     9,
      87,     8,     9,   121,    67,    23,    31,   107,   109,   150,
      51,    67,    67,    38,   130,    50,    50,   148,   148,   148,
      84,    88,     3,   122,     3,     9,   148,    51,     9,   108,
       9,     9,   123,    67,    16,    24,   115,   150,    67,    30,
      67,    36,   148,   121,   148,    11,     9,     9,     7,   114,
     124,    67,    67,     9,   121,    22
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    65,    66,    67,    67,    68,    68,    69,    69,    69,
      69,    69,    69,    69,    69,    69,    70,    71,    72,    71,
      73,    74,    75,    75,    75,    76,    77,    77,    78,    79,
      80,    80,    80,    81,    81,    81,    82,    82,    83,    83,
      84,    85,    85,    86,    86,    87,    88,    88,    89,    89,
      89,    89,    90,    90,    91,    91,    92,    91,    93,    91,
      94,    94,    94,    94,    94,    94,    94,    94,    96,    95,
      98,    97,   100,    99,   101,   101,   103,   102,   105,   104,
     106,   106,   108,   107,   109,   109,   111,   110,   113,   114,
     112,   115,   115,   117,   118,   116,   120,   119,   121,   122,
     121,   123,   124,   121,   125,   125,   125,   126,   126,   126,
     126,   126,   126,   126,   126,   126,   127,   128,   128,   129,
     129,   130,   132,   131,   133,   131,   134,   134,   134,   134,
     135,   135,   136,   137,   138,   139,   139,   140,   140,   140,
     140,   140,   140,   140,   140,   140,   140,   140,   140,   141,
     141,   142,   142,   143,   143,   143,   144,   144,   144,   144,
     145,   145,   145,   145,   145,   145,   145,   145,   145,   145,
     146,   146,   147,   147,   148,   149,   149,   149,   149,   149,
     149,   149,   149,   149,   149,   149,   149,   149,   149,   149,
     149,   149,   150
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     1,     1,     1,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     2,     0,     5,
       2,     2,     2,     3,     4,     2,     2,     2,     2,     5,
       1,     2,     3,     2,     2,     2,     1,     2,     1,     3,
       1,     1,     3,     1,     3,     2,     1,     1,     1,     1,
       1,     1,     1,     2,     3,     6,     0,     6,     0,     6,
       1,     1,     1,     1,     1,     1,     1,     1,     0,     8,
       0,     6,     0,     5,     1,     2,     0,     5,     0,     8,
       1,     2,     0,     5,     1,     4,     0,     5,     0,     0,
      13,     1,     2,     0,     0,     8,     0,     6,     2,     0,
       4,     0,     0,     8,     3,     5,     2,     4,     4,     1,
       1,     4,     3,     3,     6,     6,     2,     1,     1,     1,
       3,     1,     0,     4,     0,     4,     1,     3,     3,     3,
       2,     2,     1,     3,     3,     1,     2,     1,     1,     2,
       1,     1,     1,     3,     1,     1,     1,     1,     2,     1,
       1,     3,     1,     3,     3,     1,     3,     3,     3,     1,
       3,     3,     3,     3,     3,     3,     3,     4,     2,     1,
       3,     1,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     0
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 426 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    {return_function(0);}
#line 1945 "y.tab.c" /* yacc.c:1646  */
    break;

  case 17:
#line 450 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { start_global((yyvsp[0].str)); push("0",PUSH_NUMBER); 
						pop((yyvsp[0].str),0); end_global((yyvsp[0].str));free((yyvsp[0].str)); }
#line 1952 "y.tab.c" /* yacc.c:1646  */
    break;

  case 18:
#line 452 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { start_global((yyvsp[-1].str));}
#line 1958 "y.tab.c" /* yacc.c:1646  */
    break;

  case 19:
#line 453 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { pop((yyvsp[-3].str),0); end_global((yyvsp[-3].str));free((yyvsp[-3].str)); }
#line 1964 "y.tab.c" /* yacc.c:1646  */
    break;

  case 20:
#line 456 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { push((yyvsp[0].str),PUSH_STRING); 
					   call("import",1); pop((yyvsp[0].str),0); free((yyvsp[0].str)); }
#line 1971 "y.tab.c" /* yacc.c:1646  */
    break;

  case 21:
#line 460 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { push((yyvsp[0].str),PUSH_STRING);call("export",1); 
						pop(NULL,0);free((yyvsp[0].str)); }
#line 1978 "y.tab.c" /* yacc.c:1646  */
    break;

  case 22:
#line 464 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { end_function(NULL);}
#line 1984 "y.tab.c" /* yacc.c:1646  */
    break;

  case 23:
#line 466 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { extern_command((yyvsp[0].str),NULL); end_function(NULL); free((yyvsp[0].str));}
#line 1990 "y.tab.c" /* yacc.c:1646  */
    break;

  case 24:
#line 469 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { extern_command((yyvsp[-1].str),(yyvsp[0].str)); end_function(NULL);free((yyvsp[-1].str));free((yyvsp[0].str));}
#line 1996 "y.tab.c" /* yacc.c:1646  */
    break;

  case 25:
#line 472 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { begin_function((yyvsp[0].str),0,0,0); free((yyvsp[0].str)); }
#line 2002 "y.tab.c" /* yacc.c:1646  */
    break;

  case 26:
#line 475 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { include((yyvsp[0].str)); free((yyvsp[0].str));}
#line 2008 "y.tab.c" /* yacc.c:1646  */
    break;

  case 27:
#line 476 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { include((yyvsp[0].str)); free((yyvsp[0].str));}
#line 2014 "y.tab.c" /* yacc.c:1646  */
    break;

  case 28:
#line 479 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 2020 "y.tab.c" /* yacc.c:1646  */
    break;

  case 30:
#line 487 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { argument_count(-1); }
#line 2026 "y.tab.c" /* yacc.c:1646  */
    break;

  case 31:
#line 488 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { argument_count(0);  }
#line 2032 "y.tab.c" /* yacc.c:1646  */
    break;

  case 32:
#line 489 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { argument_count((yyvsp[-1].num)); }
#line 2038 "y.tab.c" /* yacc.c:1646  */
    break;

  case 33:
#line 492 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { begin_function((yyvsp[0].str),0,1,0); free((yyvsp[0].str));}
#line 2044 "y.tab.c" /* yacc.c:1646  */
    break;

  case 34:
#line 493 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { begin_function((yyvsp[0].str),1,1,0); free((yyvsp[0].str));}
#line 2050 "y.tab.c" /* yacc.c:1646  */
    break;

  case 35:
#line 494 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { begin_function((yyvsp[0].str),1,1,1); free((yyvsp[0].str));}
#line 2056 "y.tab.c" /* yacc.c:1646  */
    break;

  case 37:
#line 498 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { 
						call("list",(yyvsp[0].num));
						pop(".super",0);
						}
#line 2065 "y.tab.c" /* yacc.c:1646  */
    break;

  case 38:
#line 504 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { (yyval.num) = 1; }
#line 2071 "y.tab.c" /* yacc.c:1646  */
    break;

  case 39:
#line 505 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { (yyval.num) = (yyvsp[-2].num) + 1; }
#line 2077 "y.tab.c" /* yacc.c:1646  */
    break;

  case 41:
#line 511 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { (yyval.num) = 1;      }
#line 2083 "y.tab.c" /* yacc.c:1646  */
    break;

  case 42:
#line 512 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { (yyval.num) = (yyvsp[-2].num) + 1; }
#line 2089 "y.tab.c" /* yacc.c:1646  */
    break;

  case 43:
#line 515 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { param((yyvsp[0].str),NULL); free((yyvsp[0].str)); }
#line 2095 "y.tab.c" /* yacc.c:1646  */
    break;

  case 44:
#line 516 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { param((yyvsp[-2].str),(yyvsp[0].str)); free((yyvsp[-2].str));free((yyvsp[0].str));}
#line 2101 "y.tab.c" /* yacc.c:1646  */
    break;

  case 45:
#line 519 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { end_function((yyvsp[0].str));free((yyvsp[0].str)); }
#line 2107 "y.tab.c" /* yacc.c:1646  */
    break;

  case 49:
#line 529 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { pop(NULL,0); }
#line 2113 "y.tab.c" /* yacc.c:1646  */
    break;

  case 51:
#line 531 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { call((yyvsp[0].str),0);pop(NULL,0);free((yyvsp[0].str));}
#line 2119 "y.tab.c" /* yacc.c:1646  */
    break;

  case 52:
#line 534 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { return_function(0); }
#line 2125 "y.tab.c" /* yacc.c:1646  */
    break;

  case 53:
#line 535 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { return_function(1); }
#line 2131 "y.tab.c" /* yacc.c:1646  */
    break;

  case 54:
#line 539 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { pop((yyvsp[-2].str),0);free((yyvsp[-2].str)); }
#line 2137 "y.tab.c" /* yacc.c:1646  */
    break;

  case 55:
#line 541 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { 
											   pop((yyvsp[-5].str),(yyvsp[-3].num));
											   free((yyvsp[-5].str));
											 }
#line 2146 "y.tab.c" /* yacc.c:1646  */
    break;

  case 56:
#line 545 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { push((yyvsp[-1].str),PUSH_STRING); }
#line 2152 "y.tab.c" /* yacc.c:1646  */
    break;

  case 57:
#line 546 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { 
											   pop((yyvsp[-5].str),1);
											   free((yyvsp[-5].str));
											   free((yyvsp[-3].str));
											 }
#line 2162 "y.tab.c" /* yacc.c:1646  */
    break;

  case 58:
#line 551 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { push((yyvsp[-1].str),PUSH_NUMBER); }
#line 2168 "y.tab.c" /* yacc.c:1646  */
    break;

  case 59:
#line 552 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { 
											   pop((yyvsp[-5].str),1);
											   free((yyvsp[-5].str));
											   free((yyvsp[-3].str));
											 }
#line 2178 "y.tab.c" /* yacc.c:1646  */
    break;

  case 68:
#line 573 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { begin_loop((yyvsp[-2].str)); }
#line 2184 "y.tab.c" /* yacc.c:1646  */
    break;

  case 69:
#line 575 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { end_loop();     }
#line 2190 "y.tab.c" /* yacc.c:1646  */
    break;

  case 70:
#line 580 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { call(".push.dict",1);pop(NULL,0); }
#line 2196 "y.tab.c" /* yacc.c:1646  */
    break;

  case 71:
#line 582 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { call(".pop.dict",0);pop(NULL,0);  }
#line 2202 "y.tab.c" /* yacc.c:1646  */
    break;

  case 72:
#line 587 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { begin_when(); }
#line 2208 "y.tab.c" /* yacc.c:1646  */
    break;

  case 73:
#line 589 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { end_when(); }
#line 2214 "y.tab.c" /* yacc.c:1646  */
    break;

  case 76:
#line 595 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { begin_selection(); }
#line 2220 "y.tab.c" /* yacc.c:1646  */
    break;

  case 77:
#line 596 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { end_selection(); }
#line 2226 "y.tab.c" /* yacc.c:1646  */
    break;

  case 78:
#line 600 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { begin_case();    }
#line 2232 "y.tab.c" /* yacc.c:1646  */
    break;

  case 79:
#line 603 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { end_case();      }
#line 2238 "y.tab.c" /* yacc.c:1646  */
    break;

  case 82:
#line 610 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { begin_choice((yyvsp[-1].num));  }
#line 2244 "y.tab.c" /* yacc.c:1646  */
    break;

  case 83:
#line 611 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { end_choice();    }
#line 2250 "y.tab.c" /* yacc.c:1646  */
    break;

  case 86:
#line 621 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { begin_repeat(); }
#line 2256 "y.tab.c" /* yacc.c:1646  */
    break;

  case 87:
#line 623 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { end_until();    }
#line 2262 "y.tab.c" /* yacc.c:1646  */
    break;

  case 88:
#line 628 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { pop((yyvsp[-2].str),0); }
#line 2268 "y.tab.c" /* yacc.c:1646  */
    break;

  case 89:
#line 629 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { begin_for((yyvsp[-7].str),(yyvsp[-1].num)); }
#line 2274 "y.tab.c" /* yacc.c:1646  */
    break;

  case 90:
#line 631 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { end_for((yyvsp[-11].str)); free((yyvsp[-11].str)); }
#line 2280 "y.tab.c" /* yacc.c:1646  */
    break;

  case 91:
#line 634 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { (yyval.num) = 0 ; }
#line 2286 "y.tab.c" /* yacc.c:1646  */
    break;

  case 92:
#line 635 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { (yyval.num) = 1;  }
#line 2292 "y.tab.c" /* yacc.c:1646  */
    break;

  case 93:
#line 640 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { begin_while(); }
#line 2298 "y.tab.c" /* yacc.c:1646  */
    break;

  case 94:
#line 641 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { do_while();    }
#line 2304 "y.tab.c" /* yacc.c:1646  */
    break;

  case 95:
#line 643 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { end_while() ;  }
#line 2310 "y.tab.c" /* yacc.c:1646  */
    break;

  case 96:
#line 648 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { begin_if();    }
#line 2316 "y.tab.c" /* yacc.c:1646  */
    break;

  case 98:
#line 653 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { end_if();      }
#line 2322 "y.tab.c" /* yacc.c:1646  */
    break;

  case 99:
#line 654 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { else_if(); }
#line 2328 "y.tab.c" /* yacc.c:1646  */
    break;

  case 101:
#line 655 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { else_if();}
#line 2334 "y.tab.c" /* yacc.c:1646  */
    break;

  case 102:
#line 656 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { begin_if();    }
#line 2340 "y.tab.c" /* yacc.c:1646  */
    break;

  case 103:
#line 658 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { end_if();      }
#line 2346 "y.tab.c" /* yacc.c:1646  */
    break;

  case 104:
#line 663 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { call("definition",(yyvsp[-1].num));  }
#line 2352 "y.tab.c" /* yacc.c:1646  */
    break;

  case 105:
#line 664 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { call("definition",1+(yyvsp[-1].num));}
#line 2358 "y.tab.c" /* yacc.c:1646  */
    break;

  case 106:
#line 665 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { call("definition",0);   }
#line 2364 "y.tab.c" /* yacc.c:1646  */
    break;

  case 107:
#line 669 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { call((yyvsp[-3].str),(yyvsp[-1].num));free((yyvsp[-3].str)); }
#line 2370 "y.tab.c" /* yacc.c:1646  */
    break;

  case 108:
#line 670 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { call((yyvsp[-3].str),(yyvsp[-1].num));free((yyvsp[-3].str)); }
#line 2376 "y.tab.c" /* yacc.c:1646  */
    break;

  case 111:
#line 673 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { call("[]",(yyvsp[-1].num)+1);}
#line 2382 "y.tab.c" /* yacc.c:1646  */
    break;

  case 112:
#line 674 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { push((yyvsp[0].str),PUSH_STRING);
										 	call("[]",2);
										 	free((yyvsp[0].str));
										 	}
#line 2391 "y.tab.c" /* yacc.c:1646  */
    break;

  case 113:
#line 678 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { push((yyvsp[0].str),PUSH_NUMBER);
										 	call("[]",2);
										 	free((yyvsp[0].str));
										 	}
#line 2400 "y.tab.c" /* yacc.c:1646  */
    break;

  case 114:
#line 682 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { 
														push((yyvsp[-5].str),PUSH_IDENT);
														push((yyvsp[-3].str),PUSH_STRING);
														  call("method",(yyvsp[-1].num)+2);
														  free((yyvsp[-5].str));
														  free((yyvsp[-3].str));
														 }
#line 2412 "y.tab.c" /* yacc.c:1646  */
    break;

  case 115:
#line 689 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { 
														push((yyvsp[-5].str),PUSH_IDENT);
														push((yyvsp[-3].str),PUSH_STRING);
														call("method",(yyvsp[-1].num)+2);
														free((yyvsp[-5].str));
														free((yyvsp[-3].str));
														}
#line 2424 "y.tab.c" /* yacc.c:1646  */
    break;

  case 116:
#line 700 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { push((yyvsp[-1].str),PUSH_STRING); 
							  push((yyvsp[0].str),PUSH_STRING);
							  call("inline",2);
							  free((yyvsp[-1].str));free((yyvsp[0].str));
							 }
#line 2434 "y.tab.c" /* yacc.c:1646  */
    break;

  case 117:
#line 710 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { (yyval.num) = 0; }
#line 2440 "y.tab.c" /* yacc.c:1646  */
    break;

  case 119:
#line 714 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { (yyval.num) = 1;      }
#line 2446 "y.tab.c" /* yacc.c:1646  */
    break;

  case 120:
#line 715 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { (yyval.num) = (yyvsp[0].num) + 1; }
#line 2452 "y.tab.c" /* yacc.c:1646  */
    break;

  case 122:
#line 721 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { push((yyvsp[0].str),PUSH_STRING); }
#line 2458 "y.tab.c" /* yacc.c:1646  */
    break;

  case 123:
#line 721 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { free((yyvsp[-3].str)); }
#line 2464 "y.tab.c" /* yacc.c:1646  */
    break;

  case 124:
#line 722 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { push((yyvsp[0].str),PUSH_STRING); }
#line 2470 "y.tab.c" /* yacc.c:1646  */
    break;

  case 125:
#line 722 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { free((yyvsp[-3].str)); }
#line 2476 "y.tab.c" /* yacc.c:1646  */
    break;

  case 126:
#line 725 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { (yyval.num) = 2;      }
#line 2482 "y.tab.c" /* yacc.c:1646  */
    break;

  case 127:
#line 726 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { (yyval.num) = 3;      }
#line 2488 "y.tab.c" /* yacc.c:1646  */
    break;

  case 128:
#line 727 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { (yyval.num) = (yyvsp[0].num) + 2; }
#line 2494 "y.tab.c" /* yacc.c:1646  */
    break;

  case 129:
#line 728 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { (yyval.num) = (yyvsp[0].num) + 1; }
#line 2500 "y.tab.c" /* yacc.c:1646  */
    break;

  case 130:
#line 731 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { (yyval.num) = 2;      }
#line 2506 "y.tab.c" /* yacc.c:1646  */
    break;

  case 131:
#line 732 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { (yyval.num) = (yyvsp[-1].num) + 1; }
#line 2512 "y.tab.c" /* yacc.c:1646  */
    break;

  case 132:
#line 735 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { call("_matrix",(yyvsp[0].num));     }
#line 2518 "y.tab.c" /* yacc.c:1646  */
    break;

  case 133:
#line 738 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { call("_vector",(yyvsp[-1].num)); }
#line 2524 "y.tab.c" /* yacc.c:1646  */
    break;

  case 134:
#line 740 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { call("list",(yyvsp[-1].num));    }
#line 2530 "y.tab.c" /* yacc.c:1646  */
    break;

  case 135:
#line 743 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { push((yyvsp[0].str),PUSH_NUMBER); free((yyvsp[0].str));}
#line 2536 "y.tab.c" /* yacc.c:1646  */
    break;

  case 136:
#line 744 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { push((yyvsp[0].str),PUSH_NEGATIVE);free((yyvsp[0].str)); }
#line 2542 "y.tab.c" /* yacc.c:1646  */
    break;

  case 137:
#line 747 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { push((yyvsp[0].str),PUSH_IDENT);  free((yyvsp[0].str));}
#line 2548 "y.tab.c" /* yacc.c:1646  */
    break;

  case 138:
#line 748 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { push((yyvsp[0].str),PUSH_STRING); free((yyvsp[0].str));}
#line 2554 "y.tab.c" /* yacc.c:1646  */
    break;

  case 139:
#line 749 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { push((yyvsp[-1].str),PUSH_DATE);push((yyvsp[0].str),PUSH_TIME);
									  call("+",2);free((yyvsp[-1].str));free((yyvsp[0].str));}
#line 2561 "y.tab.c" /* yacc.c:1646  */
    break;

  case 140:
#line 751 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { push((yyvsp[0].str),PUSH_DATE);   free((yyvsp[0].str));}
#line 2567 "y.tab.c" /* yacc.c:1646  */
    break;

  case 141:
#line 752 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { push((yyvsp[0].str),PUSH_TIME);   free((yyvsp[0].str));}
#line 2573 "y.tab.c" /* yacc.c:1646  */
    break;

  case 147:
#line 758 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { push(NULL,PUSH_NIL); }
#line 2579 "y.tab.c" /* yacc.c:1646  */
    break;

  case 148:
#line 759 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { call("neg",1); }
#line 2585 "y.tab.c" /* yacc.c:1646  */
    break;

  case 151:
#line 768 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { call("^",2); }
#line 2591 "y.tab.c" /* yacc.c:1646  */
    break;

  case 153:
#line 772 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { call("*",2); }
#line 2597 "y.tab.c" /* yacc.c:1646  */
    break;

  case 154:
#line 773 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { call("/",2); }
#line 2603 "y.tab.c" /* yacc.c:1646  */
    break;

  case 156:
#line 777 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { call("+",2); }
#line 2609 "y.tab.c" /* yacc.c:1646  */
    break;

  case 157:
#line 778 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { call("-",2); }
#line 2615 "y.tab.c" /* yacc.c:1646  */
    break;

  case 158:
#line 779 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { call("&",2); }
#line 2621 "y.tab.c" /* yacc.c:1646  */
    break;

  case 160:
#line 783 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { call(">",2); }
#line 2627 "y.tab.c" /* yacc.c:1646  */
    break;

  case 161:
#line 784 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { call("=",2); }
#line 2633 "y.tab.c" /* yacc.c:1646  */
    break;

  case 162:
#line 785 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { call("<",2); }
#line 2639 "y.tab.c" /* yacc.c:1646  */
    break;

  case 163:
#line 786 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { call(">=",2); }
#line 2645 "y.tab.c" /* yacc.c:1646  */
    break;

  case 164:
#line 787 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { call("<=",2); }
#line 2651 "y.tab.c" /* yacc.c:1646  */
    break;

  case 165:
#line 788 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { call("<>",2); }
#line 2657 "y.tab.c" /* yacc.c:1646  */
    break;

  case 166:
#line 789 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { call("in",2); }
#line 2663 "y.tab.c" /* yacc.c:1646  */
    break;

  case 167:
#line 790 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { call("in",2); call("not",1);}
#line 2669 "y.tab.c" /* yacc.c:1646  */
    break;

  case 168:
#line 791 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { call("not",1); }
#line 2675 "y.tab.c" /* yacc.c:1646  */
    break;

  case 170:
#line 795 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { call("and",2); }
#line 2681 "y.tab.c" /* yacc.c:1646  */
    break;

  case 172:
#line 799 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { call("or",2); }
#line 2687 "y.tab.c" /* yacc.c:1646  */
    break;

  case 175:
#line 806 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { (yyval.str) = strdup(">"); }
#line 2693 "y.tab.c" /* yacc.c:1646  */
    break;

  case 176:
#line 807 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { (yyval.str) = strdup("="); }
#line 2699 "y.tab.c" /* yacc.c:1646  */
    break;

  case 177:
#line 808 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { (yyval.str) = strdup("<"); }
#line 2705 "y.tab.c" /* yacc.c:1646  */
    break;

  case 178:
#line 809 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { (yyval.str) = strdup(">=");}
#line 2711 "y.tab.c" /* yacc.c:1646  */
    break;

  case 179:
#line 810 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { (yyval.str) = strdup("<=");}
#line 2717 "y.tab.c" /* yacc.c:1646  */
    break;

  case 180:
#line 811 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { (yyval.str) = strdup("<>");}
#line 2723 "y.tab.c" /* yacc.c:1646  */
    break;

  case 181:
#line 812 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { (yyval.str) = strdup("in");}
#line 2729 "y.tab.c" /* yacc.c:1646  */
    break;

  case 182:
#line 813 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { (yyval.str) = strdup("not");}
#line 2735 "y.tab.c" /* yacc.c:1646  */
    break;

  case 183:
#line 814 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { (yyval.str) = strdup("^");}
#line 2741 "y.tab.c" /* yacc.c:1646  */
    break;

  case 184:
#line 815 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { (yyval.str) = strdup("*");}
#line 2747 "y.tab.c" /* yacc.c:1646  */
    break;

  case 185:
#line 816 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { (yyval.str) = strdup("/");}
#line 2753 "y.tab.c" /* yacc.c:1646  */
    break;

  case 186:
#line 817 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { (yyval.str) = strdup("+");}
#line 2759 "y.tab.c" /* yacc.c:1646  */
    break;

  case 187:
#line 818 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { (yyval.str) = strdup("-");}
#line 2765 "y.tab.c" /* yacc.c:1646  */
    break;

  case 188:
#line 819 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { (yyval.str) = strdup("&");}
#line 2771 "y.tab.c" /* yacc.c:1646  */
    break;

  case 189:
#line 820 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { (yyval.str) = strdup("and");}
#line 2777 "y.tab.c" /* yacc.c:1646  */
    break;

  case 190:
#line 821 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { (yyval.str) = strdup("or");}
#line 2783 "y.tab.c" /* yacc.c:1646  */
    break;

  case 191:
#line 822 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1646  */
    { (yyval.str) = strdup("[]"); }
#line 2789 "y.tab.c" /* yacc.c:1646  */
    break;


#line 2793 "y.tab.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 828 "/builddir/build/BUILD/Metview-5.7.4-Source/metview/src/Macro/macroy.y" /* yacc.c:1906  */

#include "macrol.c"

